
import 'package:origami_endpoint/service/sessionManager/jwtSessionManager.dart';
import 'package:origamicore/models/packageIndex.dart';
import 'package:origamicore/models/serviceRoute.dart';
import 'package:origamicore/routing/router.dart';

import 'models/endpointConfig.dart';
import 'service/httpIndex.dart';
import 'service/socketIndex.dart';

class EndpointIndex extends PackageIndex
{
  EndpointConfig _cf=EndpointConfig();
  @override
  Future jsonConfig(config) async { 
    Router.addRoute('endpoint', ServiceRoute(services: {}));
    for(var a in config)
    {
      if(a['type']=='endpoint')
      {
        _cf=EndpointConfig()..fromJson(a);
      }
    }
    
    for(var conf in _cf.connections )
    {
      if(conf.type=='socket')
      {
         SocketIndex(connection: conf);
      }
      else
      {
        var http= HttpIndex(connection: conf);
        if(conf.protocol.jwtConfig!=null)
        {
           http.sessionManager=JwtSessionManager();
           await http.sessionManager.init(conf.protocol.jwtConfig);
        }
      }
    }
  }
 

  @override
  void restart() {
    // TODO: implement restart
  }

  @override
  Future start() async {
    // TODO: implement start
  }

  @override
  void stop() {
    // TODO: implement stop
  }

}