
import 'package:origami_endpoint/models/authzEndpoint.dart';
import 'package:origami_endpoint/models/connectionProtocol.dart';
import 'package:origamicore/models/serializedObject.dart';

class EndpointConnection extends SerializedObject
{
  String name;
  String bindAddress;
  String type;
  String sessionManager;
  AuthzEndpoint authz;
  ConnectionProtocol protocol;
 EndpointConnection({this.name,this.bindAddress,this.type,this.sessionManager,this.authz,this.protocol,  });
  @override
  void fromJson(dynamic data)
  { 
    if(data['name']!=null) name=data['name'];
    if(data['bindAddress']!=null) bindAddress=data['bindAddress'];
    if(data['type']!=null) type=data['type'];
    if(data['sessionManager']!=null) sessionManager=data['sessionManager'];
    if(data['authz']!=null) authz=AuthzEndpoint()..fromJson(data['authz']);
    if(data['protocol']!=null) protocol=ConnectionProtocol()..fromJson(data['protocol']);
  }
  @override
  dynamic toJson()
  { 
  	var data ={};
      data['name']=name; 
      data['bindAddress']=bindAddress; 
      data['type']=type; 
      data['sessionManager']=sessionManager; 
      data['authz']=authz?.toJson(); 
      data['protocol']=protocol?.toJson(); 
  	return data;
  }
}